# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .data import Data
from .embeddings_response_encoding_format import EmbeddingsResponseEncodingFormat
from .object_type import ObjectType
from .usage import Usage

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class EmbeddingsResponse(pydantic.BaseModel):
    usage: Usage = pydantic.Field()
    """
    The usage of the model
    """

    model: str = pydantic.Field()
    """
    The model used
    """

    data: Data = pydantic.Field()
    """
    The created embeddings
    """

    object: typing.Optional[ObjectType] = pydantic.Field(default=None)
    """
    The object type of the response
    """

    normalized: bool = pydantic.Field()
    """
    Whether the embeddings are normalized
    """

    encoding_format: EmbeddingsResponseEncodingFormat
    dimensions: typing.Optional[int] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
